/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from viewporter.xml by mir_wayland_generator
 */

#include "viewporter_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const wp_viewport_interface_data;
extern struct wl_interface const wp_viewporter_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// Viewporter

struct mw::Viewporter::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<Viewporter*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewporter::destroy()");
        }
    }

    static void get_viewport_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &wp_viewport_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<Viewporter*>(wl_resource_get_user_data(resource));
            me->get_viewport(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewporter::get_viewport()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<Viewporter*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<Viewporter::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &wp_viewporter_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewporter global bind");
        }
    }

    static struct wl_interface const* get_viewport_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::Viewporter::Thunks::supported_version = 1;

mw::Viewporter::Viewporter(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::Viewporter::~Viewporter()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::Viewporter::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &wp_viewporter_interface_data, Thunks::request_vtable);
}

uint32_t const mw::Viewporter::Error::viewport_exists;

mw::Viewporter::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &wp_viewporter_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::Viewporter::Global::interface_name() const -> char const*
{
    return Viewporter::interface_name;
}

struct wl_interface const* mw::Viewporter::Thunks::get_viewport_types[] {
    &wp_viewport_interface_data,
    &wl_surface_interface_data};

struct wl_message const mw::Viewporter::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"get_viewport", "no", get_viewport_types}};

void const* mw::Viewporter::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::get_viewport_thunk};

mw::Viewporter* mw::Viewporter::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &wp_viewporter_interface_data, Viewporter::Thunks::request_vtable))
    {
        return static_cast<Viewporter*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// Viewport

struct mw::Viewport::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<Viewport*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewport::destroy()");
        }
    }

    static void set_source_thunk(struct wl_client* client, struct wl_resource* resource, wl_fixed_t x, wl_fixed_t y, wl_fixed_t width, wl_fixed_t height)
    {
        double x_resolved{wl_fixed_to_double(x)};
        double y_resolved{wl_fixed_to_double(y)};
        double width_resolved{wl_fixed_to_double(width)};
        double height_resolved{wl_fixed_to_double(height)};
        try
        {
            auto me = static_cast<Viewport*>(wl_resource_get_user_data(resource));
            me->set_source(x_resolved, y_resolved, width_resolved, height_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewport::set_source()");
        }
    }

    static void set_destination_thunk(struct wl_client* client, struct wl_resource* resource, int32_t width, int32_t height)
    {
        try
        {
            auto me = static_cast<Viewport*>(wl_resource_get_user_data(resource));
            me->set_destination(width, height);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "Viewport::set_destination()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<Viewport*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::Viewport::Thunks::supported_version = 1;

mw::Viewport::Viewport(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::Viewport::~Viewport()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::Viewport::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &wp_viewport_interface_data, Thunks::request_vtable);
}

uint32_t const mw::Viewport::Error::bad_value;
uint32_t const mw::Viewport::Error::bad_size;
uint32_t const mw::Viewport::Error::out_of_buffer;
uint32_t const mw::Viewport::Error::no_surface;

struct wl_message const mw::Viewport::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"set_source", "ffff", all_null_types},
    {"set_destination", "ii", all_null_types}};

void const* mw::Viewport::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::set_source_thunk,
    (void*)Thunks::set_destination_thunk};

mw::Viewport* mw::Viewport::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &wp_viewport_interface_data, Viewport::Thunks::request_vtable))
    {
        return static_cast<Viewport*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const wp_viewporter_interface_data {
    mw::Viewporter::interface_name,
    mw::Viewporter::Thunks::supported_version,
    2, mw::Viewporter::Thunks::request_messages,
    0, nullptr};

struct wl_interface const wp_viewport_interface_data {
    mw::Viewport::interface_name,
    mw::Viewport::Thunks::supported_version,
    3, mw::Viewport::Thunks::request_messages,
    0, nullptr};

}
}
